﻿Imports System.Windows.Forms

Public Class ConfigDialog

    Public Structure DispSetting
        Public FontName As String
        Public FontSize As Single
        Public ForeColor As Color
        Public BackColor As Color
        Public UnderLine As Boolean
    End Structure
    Public Structure FirstSongFontSetting
        Public TreeSetting As DispSetting
        Public ListSetting As DispSetting
        Public InfoSetting As DispSetting
    End Structure

    Public dispFont As FirstSongFontSetting

    Public Sub New()

        ' この呼び出しはデザイナーで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。

    End Sub

    Private Sub OK_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.OK
        Me.Close()
    End Sub

    Private Sub Cancel_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Cancel_Button.Click
        Me.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub lstDispItem_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstDispItem.SelectedIndexChanged
        Select Case lstDispItem.SelectedIndex
            Case 0
                'Tree
                txtDispFont.Text = dispFont.TreeSetting.FontName
                nudDispFont.Text = dispFont.TreeSetting.FontSize.ToString
                btnDispTextColor.SelectColor = dispFont.TreeSetting.ForeColor
                btnDispBackColor.SelectColor = dispFont.TreeSetting.BackColor
                chkDispUnder.Visible = True
                chkDispUnder.Checked = dispFont.TreeSetting.UnderLine
            Case 1
                'List
                txtDispFont.Text = dispFont.ListSetting.FontName
                nudDispFont.Text = dispFont.ListSetting.FontSize.ToString
                btnDispTextColor.SelectColor = dispFont.ListSetting.ForeColor
                btnDispBackColor.SelectColor = dispFont.ListSetting.BackColor
                chkDispUnder.Visible = False
                chkDispUnder.Checked = dispFont.ListSetting.UnderLine
            Case 2
                'Info
                txtDispFont.Text = dispFont.InfoSetting.FontName
                nudDispFont.Text = dispFont.InfoSetting.FontSize.ToString
                btnDispTextColor.SelectColor = dispFont.InfoSetting.ForeColor
                btnDispBackColor.SelectColor = dispFont.InfoSetting.BackColor
                chkDispUnder.Visible = False
                chkDispUnder.Checked = dispFont.InfoSetting.UnderLine
        End Select
    End Sub

    Private Sub btnDispFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispFont.Click
        Try
            With diaFont
                .AllowScriptChange = True
                .AllowSimulations = True
                .AllowVectorFonts = True
                .AllowVerticalFonts = False
                .FixedPitchOnly = False
                .ShowColor = False
                .ShowEffects = False
                .FontMustExist = True
                .Font = New Font(txtDispFont.Text, nudDispFont.Value)
                If .ShowDialog = DialogResult.OK Then
                    txtDispFont.Text = .Font.FontFamily.Name
                    nudDispFont.Value = .Font.Size
                    Select Case lstDispItem.SelectedIndex
                        Case 0
                            dispFont.TreeSetting.FontName = txtDispFont.Text
                            dispFont.TreeSetting.FontSize = nudDispFont.Value
                            dispFont.TreeSetting.UnderLine = chkDispUnder.Checked
                        Case 1
                            dispFont.ListSetting.FontName = txtDispFont.Text
                            dispFont.ListSetting.FontSize = nudDispFont.Value
                        Case 2
                            dispFont.InfoSetting.FontName = txtDispFont.Text
                            dispFont.InfoSetting.FontSize = nudDispFont.Value
                    End Select
                End If
            End With
        Catch ex As Exception
            MessageBox.Show("指定のフォントは使用できません")
        End Try
    End Sub

    Private Sub btnDispTextColor_BackColorChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDispTextColor.BackColorChanged
        Select Case lstDispItem.SelectedIndex
            Case 0
                dispFont.TreeSetting.ForeColor = btnDispTextColor.BackColor
            Case 1
                dispFont.ListSetting.ForeColor = btnDispTextColor.BackColor
            Case 2
                dispFont.InfoSetting.ForeColor = btnDispTextColor.BackColor
        End Select
    End Sub

    Private Sub btnDispBackColor_BackColorChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDispBackColor.BackColorChanged
        Select Case lstDispItem.SelectedIndex
            Case 0
                dispFont.TreeSetting.BackColor = btnDispBackColor.BackColor
            Case 1
                dispFont.ListSetting.BackColor = btnDispBackColor.BackColor
            Case 2
                dispFont.InfoSetting.BackColor = btnDispBackColor.BackColor
        End Select
    End Sub

    Private Sub btnRefDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRefDir.Click
        With diaFolder
            .SelectedPath = txtLocalDir.Text
            If .ShowDialog = DialogResult.OK Then
                txtLocalDir.Text = .SelectedPath
            End If
        End With
    End Sub

    Private Sub nudDispFont_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles nudDispFont.ValueChanged
        Select Case lstDispItem.SelectedIndex
            Case 0
                dispFont.TreeSetting.FontSize = nudDispFont.Value
            Case 1
                dispFont.ListSetting.FontSize = nudDispFont.Value
            Case 2
                dispFont.InfoSetting.FontSize = nudDispFont.Value
        End Select
    End Sub

    Private Sub chkDispUnder_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDispUnder.CheckedChanged
        Select Case lstDispItem.SelectedIndex
            Case 0
                dispFont.TreeSetting.UnderLine = chkDispUnder.Checked
            Case 1
                dispFont.ListSetting.UnderLine = chkDispUnder.Checked
            Case 2
                dispFont.InfoSetting.UnderLine = chkDispUnder.Checked
        End Select
    End Sub
End Class

